package index.adjust;

import index.entity.Point;

import index.fit.Fit;

import java.util.ArrayList;

import java.util.HashMap;

import java.util.Map;

public class Adjust {

    public ArrayList<Point> adjustShape(ArrayList<Point> initialShapeList,ArrayList<Point> changedShapeList,Integer adjustSize){

        Integer size = initialShapeList.size();

        ArrayList<Point> afterAdjustPointsList = new ArrayList<>();

        Integer round = size / adjustSize;

        for (int i = 0; i < round ;i++){

            Integer indexBegin = i * adjustSize;
            Integer indexEnd = indexBegin + adjustSize;

            Double avgDec = 0.0;
            //
            ArrayList<Point> pointArrayList = new ArrayList<>();//存放差值,借用arraylist<point>

            for (int j = indexBegin;j < indexEnd; j++){
                Point iniPoint = initialShapeList.get(j);
                Point chaPoint = changedShapeList.get(j);
                Point pointDis = new Point();
                pointDis.setColY(chaPoint.getColY() - iniPoint.getColY());
                pointDis.setColX(chaPoint.getColX());
                pointArrayList.add(pointDis);
                avgDec = avgDec + chaPoint.getColY() - iniPoint.getColY();
            }

            avgDec = avgDec / adjustSize;

            for (int j = indexBegin ; j < indexEnd;j++){

                Point intPoint = initialShapeList.get(j);
                Point adjustPoint = new Point();
                adjustPoint.setColX(intPoint.getColX());
                adjustPoint.setColY(intPoint.getColY() + avgDec);

                afterAdjustPointsList.add(adjustPoint);
            }
            //后面扩充不整除的情况
        }
        return afterAdjustPointsList;
    }

    //输入的list都已经处理过，是图形的一半
    public ArrayList<Point> fillZero(ArrayList<Point> initialShapeList,ArrayList<Point> changedShapeList,Integer scale) {

        ArrayList<Double> diffValueList = new ArrayList<>();

        ArrayList<Map> nonZeroDiffInfoMapList = new ArrayList<>();

        for (int i = 0 ; i < changedShapeList.size();i++){

            Point chaPoint = changedShapeList.get(i);

            Point iniPoint = initialShapeList.get(i);

            Double diff = chaPoint.getColY() - iniPoint.getColY();

            diffValueList.add(diff);

        }

        for (int i = 0;i < diffValueList.size();i++){
            Double diff = diffValueList.get(i);
            if (!isCloseToZero(diff)){

                Map nonZeroInfoMap = new HashMap();

                nonZeroInfoMap.put("INDEX",i);

                nonZeroDiffInfoMapList.add(nonZeroInfoMap);

            }
        }

        //记录下需要填充的列的信息
        if (nonZeroDiffInfoMapList.size() >=2){

            for (int i = 0 ; i < nonZeroDiffInfoMapList.size() - 1; i++){

                Map map1 = nonZeroDiffInfoMapList.get(i);
                Map map2 = nonZeroDiffInfoMapList.get(i+1);
                Integer index1 = (int)map1.get("INDEX");
                Integer index2 = (int)map2.get("INDEX");

                Double beginDiff = diffValueList.get(index1);
                Double endDiff = diffValueList.get(index2);

                Double gap = (endDiff - beginDiff) / (index2 - index1);

                if ((index2 - index1 <= scale) && ((index2 - index1) != 1)){

                    for (int j = index1 + 1; j < index2;j++){

                        diffValueList.set(j,beginDiff + (j - index1) * gap);

                    }

                }

            }

        }

        for (int i = 0 ; i < initialShapeList.size();i++){

            Point point = new Point();

            Point iniPoint = initialShapeList.get(i);

            point.setColX(iniPoint.getColX());

            point.setColY(iniPoint.getColY() + diffValueList.get(i));

            changedShapeList.set(i,point);
        }

        return changedShapeList;

    }

    //首尾相连的list
    public ArrayList<Point> fillArrayListPlus(ArrayList<Point> initialShapeList,ArrayList<Point> changedShapeList,Integer scale){

        Fit fit = new Fit();
        initialShapeList = removeLastPoint(initialShapeList);
        changedShapeList = removeLastPoint(changedShapeList);
        Integer listLength = initialShapeList.size();
        ArrayList<Point> subInitialShapeList1 = fit.getSubArrayList(initialShapeList,0,listLength / 2);
        ArrayList<Point> subInitialShapeList2 = fit.getSubArrayList(initialShapeList,listLength / 2,listLength);
        ArrayList<Point> subChangedShapeList1 = fit.getSubArrayList(changedShapeList,0,listLength / 2);
        ArrayList<Point> subChangedShapeList2 = fit.getSubArrayList(changedShapeList,listLength / 2 ,listLength);

        ArrayList<Point> subChangedShapeList1New = fillZero(subInitialShapeList1,subChangedShapeList1,scale);
        ArrayList<Point> subChangedShapeList2New = fillZero(subInitialShapeList2,subChangedShapeList2,scale);

        ArrayList<Point> changedShapeListNew = new ArrayList<>();
        changedShapeListNew.addAll(subChangedShapeList1New);
        changedShapeListNew.addAll(subChangedShapeList2New);
        changedShapeListNew.add(changedShapeListNew.get(0));
        return changedShapeListNew;
    }


    //
    public ArrayList<Point> removeLastPoint(ArrayList<Point> pointArrayListForRemove){

        ArrayList<Point> pointArrayListAfterRemove = new ArrayList<>();

        for (int i = 0 ; i < pointArrayListForRemove.size() - 1;i++){

            pointArrayListAfterRemove.add(pointArrayListForRemove.get(i));

        }

        return pointArrayListAfterRemove;

    }

    public boolean isCloseToZero(Double diff){

        if (Math.abs(diff) < 2){

            return true;
        }
        else return false;

    }

}
