package index.alg;

import index.adjust.Adjust;
import index.adjust.PointXYCorRevise;
import index.alg.analyse.CalHpTimeDistance;
import index.entity.OccupyPerX;
import index.entity.Point;
import index.entity.WholeIndexOccupy;
import index.fit.Fit;
import java.util.ArrayList;
import java.util.Date;

public class Cal {
    ArrayList<OccupyPerX> occupyPerXArrayList = new ArrayList<>();//占用情况
    Integer numOfGaps = 100;
    Fit fit = new Fit();

    public ArrayList<Point> calShape(Integer workDirection) throws Exception {
        GetPoints getPoints = new GetPoints();
        getPoints.getPoints(workDirection);
        ArrayList<Point> realShapePoints = getPoints.realShapePoints;//实际形状的平面坐标
        ArrayList<Point> allPoints = getPoints.allPoints;//所有待计算点，铲车作业平面坐标
        ///
        ArrayList<ArrayList<Date>> dateForAna = getPoints.dateForAna;
        CalHpTimeDistance calHpTimeDistance = new CalHpTimeDistance(dateForAna);
        calHpTimeDistance.buildDistribution(10);
        ///
        System.out.println("未过滤前点数量 ： " + allPoints.size() );
        Split split = new Split();
        split.cal(realShapePoints);
        ArrayList<Double> xIndexCorList = split.xIndexCorList;//格点横坐标List
        ArrayList<Double> yIndexCorList = split.yIndexCorList;//格点纵坐标List
        WholeIndexOccupy wholeIndexOccupy = split.wholeIndexOccupy;//初始垛位的占用情况
        Double xGap = split.xGap;//横向上采用的间隔
        Double yGap = split.yGap;//纵向上采用的间隔
        Double minX = xIndexCorList.get(0);
        Double maxX = xIndexCorList.get(xIndexCorList.size() - 1);
        Double minY = yIndexCorList.get(0);
        Double maxY = yIndexCorList.get(yIndexCorList.size() - 1);
        wholeIndexOccupy.printOccupy(minX,minY,xGap,yGap);
        ArrayList<Point> occupyShapeList = wholeIndexOccupy.getOccupyPointsArrayList();//坐标形式的初始形状
        ArrayList<Point> pointAfterExclude = new ArrayList<>();//过滤后的所有点的坐标
        //对待计算点，进行过滤，过滤掉在网格以外的，这部分后面单独写个过滤类
        for(int i = 0 ; i < allPoints.size();i++){
            Point point = allPoints.get(i);
            Double corX = point.getColX();
            Double corY = point.getColY();
            if ( (corX < maxX) && (corX > minX) && (corY < maxY) && (corY > minY)){
                pointAfterExclude.add(point);
            }
        }
        System.out.println("过滤后点数量：" + pointAfterExclude.size());

        //
        BoxFlow boxFlow = new BoxFlow();
        boxFlow.start(realShapePoints,pointAfterExclude);
        //



        //占用的网格为1，不占用的网格0
        ArrayList<ArrayList<Integer>> occupyList = changeWholeIndexOccupyToList(wholeIndexOccupy);


        for (int i = 0; i < pointAfterExclude.size();i++){

            Point point = pointAfterExclude.get(i);
            Double x = point.getColX();
            Double y = point.getColY();



            Integer xIndex = split.identifyXIndex(x);
            Integer yIndex = split.identifyYIndex(y);

            //检查占用，如果占用了就把1设置成0，
            if (yIndex < numOfGaps && yIndex >=0){
                ArrayList<Integer> arrayList = occupyList.get(xIndex);
                arrayList.set(yIndex,0);
                occupyList.set(xIndex,arrayList);
            }
        }

        for (int i = 0 ; i < occupyList.size();i++){
            ArrayList<Integer> arrayList = occupyList.get(i);

            StringBuffer sb = new StringBuffer();
            StringBuffer sb1 = new StringBuffer();
            for (int jj = 0 ; jj < arrayList.size();jj++){
                if (arrayList.get(jj).toString().equals("0")){
                    sb.append(" ");
                    sb1.append("+");
                }
                else {
                    sb.append(arrayList.get(jj).toString());
                    sb1.append(arrayList.get(jj).toString());
                }
            }
            String arrayListString = sb.toString();
            String arrayListString1 = sb1.toString();
            String[] arrays = arrayListString.split("\\s+");
            String maxString ="";
            //这里需要再想想
            for (int j = 0 ; j < arrays.length;j++){
                    String temp = arrays[j];
                    if (temp.length() > maxString.length()){
                        maxString = temp;
                    }
            }
            Integer indexBegin = arrayListString.indexOf(maxString) - 1;
            Integer indexEnd = indexBegin + maxString.length();
            OccupyPerX occupyPerX = new OccupyPerX();
            occupyPerX.setMinYIndex(indexBegin);
            occupyPerX.setMaxYIndex(indexEnd);
            occupyPerXArrayList.add(occupyPerX);
        }
        ArrayList<Point> shape = new ArrayList<>();
        for (int i = 0 ; i < occupyPerXArrayList.size();i++){
            OccupyPerX occupyPerX = occupyPerXArrayList.get(i);
            Double xCor = minX + i * xGap + 0.5 * xGap;
            Integer yIndex = occupyPerX.maxYIndex;
            Double yCor = minY + yIndex * yGap + 0.5 * yGap;
            Point point = new Point();
            point.setColX(xCor);
            point.setColY(yCor);
            shape.add(point);

        }

        for (int i = (occupyPerXArrayList.size() -1) ; i >=0;i--){
            OccupyPerX occupyPerX = occupyPerXArrayList.get(i);
            Double xCor = minX + i * xGap + 0.5 * xGap;
            Integer yIndex = occupyPerX.minYIndex;
            Double yCor = minY + yIndex * yGap + 0.5 * yGap;
            Point point = new Point();
            point.setColX(xCor);
            point.setColY(yCor);
            shape.add(point);

        }

        //对算法结果做一些调整


        ArrayList<Point> shapeFill = fit.allCircleFitDefault(shape);


        //填充空值
        Adjust adjust = new Adjust();
        shape.add(shape.get(0));
        ArrayList<Point> afterAdjustPointsList = adjust.fillArrayListPlus(occupyShapeList,shape,10);

        ///打印,临时用的，主要是为了调整坐标
        PointXYCorRevise pointXYCorRevise = new PointXYCorRevise();
        //测试
        for (int i = 0 ; i <realShapePoints.size();i++){

            Point point  = realShapePoints.get(i);

        }

        realShapePoints = pointXYCorRevise.revise(realShapePoints);
        afterAdjustPointsList = pointXYCorRevise.revise(afterAdjustPointsList);
        pointAfterExclude = pointXYCorRevise.revise(pointAfterExclude);

        for (int i = 0 ; i < realShapePoints.size();i++){

            Point point  = realShapePoints.get(i);

        }

        return shape;

    }



    public ArrayList<ArrayList<Integer>> changeWholeIndexOccupyToList(WholeIndexOccupy wholeIndexOccupy){

        ArrayList<OccupyPerX> occupyPerXArrayList = wholeIndexOccupy.getOccupyPerXArrayList();


        Integer numOfGaps = occupyPerXArrayList.size();

        ArrayList<ArrayList<Integer>> occupyList = new ArrayList<>();

        for (int i = 0 ; i < numOfGaps;i++){

            ArrayList<Integer> arrayList = new ArrayList<>();

            for (int j = 0 ; j < numOfGaps ; j++){

                arrayList.add(0);

            }
            occupyList.add(arrayList);
        }

        for (int i = 0 ; i < occupyPerXArrayList.size(); i++){

            OccupyPerX occupyPerX =  occupyPerXArrayList.get(i);

            Integer minYIndex = occupyPerX.getMinYIndex();

            Integer maxYIndex = occupyPerX.getMaxYIndex();

            ArrayList<Integer> arrayList = occupyList.get(i);


            for (int j = minYIndex ; j < (maxYIndex + 1); j++){

                arrayList.set(j,1);

            }

            occupyList.set(i,arrayList);

        }

        return occupyList;

    }


    public ArrayList<Point> adjustShape(ArrayList<Point> initialShapeList,ArrayList<Point> changedShapeList,Integer adjustSize){

        Integer size = initialShapeList.size();
//
        ArrayList<Point> afterAdjustPointsList = new ArrayList<>();

        Integer round = size / adjustSize;

        for (int i = 0; i < round ;i++){

            Integer indexBegin = i * adjustSize;
            Integer indexEnd = indexBegin + adjustSize;

            Double avgDec = 0.0;
            ArrayList<Point> pointArrayList = new ArrayList<>();//存放差值,借用arraylist<point>

            for (int j = indexBegin;j < indexEnd; j++){
                Point iniPoint = initialShapeList.get(j);
                Point chaPoint = changedShapeList.get(j);
                Point pointDis = new Point();
                pointDis.setColY(chaPoint.getColY() - iniPoint.getColY());
                pointDis.setColX(chaPoint.getColX());
                pointArrayList.add(pointDis);
                avgDec = avgDec + chaPoint.getColY() - iniPoint.getColY();
            }

            avgDec = avgDec / adjustSize;

            for (int j = indexBegin ; j < indexEnd;j++){

                Point intPoint = initialShapeList.get(j);
                Point adjustPoint = new Point();
                adjustPoint.setColX(intPoint.getColX());
                adjustPoint.setColY(intPoint.getColY() + avgDec);

                afterAdjustPointsList.add(adjustPoint);
            }
            //后面扩充不整除的情况
        }

        return afterAdjustPointsList;

    }

}
