package index.alg;


import index.adjust.PointXYCorRevise;
import index.gps.GpsExchange;
import index.db.ConnectToSourceDB;
import index.db.DbOperate;
import index.entity.Point;
import index.file.OperateFile;
import index.log.Log;

import java.io.FileNotFoundException;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Date;



//暂时先自己写connection从数据库中获取

public class GetPoints {

    String userName = "nps_tc01";
    String password = "nps_tc01";
    String driver = "oracle.jdbc.driver.OracleDriver";
    String url = "jdbc:oracle:thin:@172.16.2.114:1521:orcl1";


    ArrayList<Point> realShapePoints = new ArrayList<>();
    ArrayList<Point> allPoints = new ArrayList<>();
    ArrayList<ArrayList<Date>> dateForAna = new ArrayList<>();

    public ArrayList<Point> returnPoints(){

        ArrayList<Point> pointList = new ArrayList<>();

        return pointList;

    }

    public void getPoints(Integer workDirection) throws SQLException, FileNotFoundException {

        String realShapeBeginTime = "2020-09-08 15:17:14.000000";
        String realShapeEndTime = "2020-09-08 15:19:37.000000";

        realShapePoints = buildPointsFromFile("/Users/haoqianpan/file/programfile/meanshift/in/a49shape.txt",workDirection);
        //
        ArrayList<String> machineIdList = new ArrayList<>();
        ArrayList<String> allPointsBeginTimeList = new ArrayList<>();
        ArrayList<String> allPointsEndTimeList = new ArrayList<>();
        //a49
        machineIdList.add("港装K736");
        allPointsBeginTimeList.add("2020-09-11 12:11:00.000000");
        allPointsEndTimeList.add("2020-09-18 10:20:00.000000");

        machineIdList.add("港装K121");
        allPointsBeginTimeList.add("2020-09-17 13:35:00.000000");
        allPointsEndTimeList.add("2020-09-18 08:12:00.000000");

        Log.print("开始查询作业点");
        for (int i  = 0 ; i < (machineIdList.size());i++){

            String machineId = machineIdList.get(i);
            String beginTime = allPointsBeginTimeList.get(i);
            String endTime = allPointsEndTimeList.get(i);
            String allPointsQuerySql = sqlFactory(beginTime,endTime,machineId);
            ArrayList<Point> pointsTemp = buildPoints(allPointsQuerySql,workDirection);
            allPoints.addAll(pointsTemp);

        }
        Log.print("作业点查询结束");

    }

    public ArrayList<Point> buildPoints(String sql,Integer workDirection) throws SQLException {
        ArrayList<Point> pointArrayList = new ArrayList<>();
        ConnectToSourceDB connectToSourceDB = new ConnectToSourceDB();
        connectToSourceDB.setConnPara(userName,password,driver,url);
        Connection connection = connectToSourceDB.getConnection();
        DbOperate dbOperate = new DbOperate();

        ResultSet resultSet = dbOperate.runQuerySql(connection,sql);
        GpsExchange gpsExchange = new GpsExchange();
        ArrayList<Date> dateArrayList = new ArrayList<>();


        while (resultSet.next()){

            Double lat = resultSet.getDouble(1);
            Double lon = resultSet.getDouble(2);
            Date date = resultSet.getDate(3);
            dateArrayList.add(date);
            Point point = gpsExchange.gpsToPoints(lat,lon);
            pointArrayList.add(point);

        }
        dateForAna.add(dateArrayList);
        System.out.println("sql: " + sql);
        System.out.println("pointsize " + pointArrayList.size());

        PointXYCorRevise pointXYCorRevise = new PointXYCorRevise();
        if (workDirection == 1){

            pointArrayList = pointXYCorRevise.revise(pointArrayList);

        }

        return pointArrayList;
    }

    public ArrayList<Point> buildPointsFromFile(String filePath,Integer workDirection) throws FileNotFoundException {
        OperateFile operateFile = new OperateFile();
        ArrayList<Point> pointArrayList  = operateFile.readPointsFromFile(filePath);
        GpsExchange gpsExchange = new GpsExchange();
        for (int i = 0 ; i < pointArrayList.size();i++){

            Point point = pointArrayList.get(i);
            point = gpsExchange.gpsToPoints(point.getColX(),point.getColY());
            pointArrayList.set(i,point);

        }

        PointXYCorRevise pointXYCorRevise = new PointXYCorRevise();
        if (workDirection == 1){

            pointArrayList = pointXYCorRevise.revise(pointArrayList);

        }

        return pointArrayList;

    }

    public String sqlFactory(String beginTime,String endTime,String machineId){

        String sql = "select GPS_LAT,GPS_LON,CLIENT_RECORD_TIME from T_LOC_APP_CLIENT_STATUS@DBLINKLOC WHERE CLIENT_RECORD_TIME between to_timestamp('" + beginTime  + "', 'yyyy-mm-dd hh24:mi:ss.ff') and to_timestamp('" + endTime + "', 'yyyy-mm-dd hh24:mi:ss.ff') and (GPS_SOURCE_TYPE = '千寻(4)' OR GPS_SOURCE_TYPE = '千寻(5)') and MACHINE_ID = '" + machineId +"' order by CLIENT_RECORD_TIME asc"  ;
//        String sql = "select GPS_LAT,GPS_LON from T_LOC_APP_CLIENT_STATUS@DBLINKLOC WHERE CLIENT_RECORD_TIME between to_timestamp('" + beginTime  + "', 'yyyy-mm-dd hh24:mi:ss.ff') and to_timestamp('" + endTime + "', 'yyyy-mm-dd hh24:mi:ss.ff') and GPS_SOURCE_TYPE != '千寻(4)' and GPS_SOURCE_TYPE != '千寻(5)' and MACHINE_ID = '" + machineId +"'"  ;
//        String sql = "select GPS_LAT,GPS_LON,CLIENT_RECORD_TIME from T_LOC_APP_CLIENT_STATUS@DBLINKLOC WHERE CLIENT_RECORD_TIME between to_timestamp('" + beginTime  + "', 'yyyy-mm-dd hh24:mi:ss.ff') and to_timestamp('" + endTime + "', 'yyyy-mm-dd hh24:mi:ss.ff') and MACHINE_ID = '" + machineId +"'" ;
        return sql;

    }
    public String sqlFactoryTemp(String beginTime,String endTime,String machineId){

//        String sql = "select GPS_LAT,GPS_LON from T_LOC_APP_CLIENT_STATUS@DBLINKLOC WHERE CLIENT_RECORD_TIME between to_timestamp('" + beginTime  + "', 'yyyy-mm-dd hh24:mi:ss.ff') and to_timestamp('" + endTime + "', 'yyyy-mm-dd hh24:mi:ss.ff') and (GPS_SOURCE_TYPE = '千寻(4)' OR GPS_SOURCE_TYPE = '千寻(5)') and MACHINE_ID = '" + machineId +"'"  ;
        String sql = "select GPS_LAT,GPS_LON,CLIENT_RECORD_TIME from T_LOC_APP_CLIENT_STATUS@DBLINKLOC WHERE CLIENT_RECORD_TIME between to_timestamp('" + beginTime  + "', 'yyyy-mm-dd hh24:mi:ss.ff') and to_timestamp('" + endTime + "', 'yyyy-mm-dd hh24:mi:ss.ff') and GPS_SOURCE_TYPE != '千寻(4)' and GPS_SOURCE_TYPE != '千寻(5)' and MACHINE_ID = '" + machineId +"' order by CLIENT_RECORD_TIME asc"  ;
//        String sql = "select GPS_LAT,GPS_LON from T_LOC_APP_CLIENT_STATUS@DBLINKLOC WHERE CLIENT_RECORD_TIME between to_timestamp('" + beginTime  + "', 'yyyy-mm-dd hh24:mi:ss.ff') and to_timestamp('" + endTime + "', 'yyyy-mm-dd hh24:mi:ss.ff') and MACHINE_ID = '" + machineId +"'" ;
        return sql;

    }



}
